/*
	Code generation for the following grammar segment:
	
	BehaviorDeclarationAttributes := ("abstract" | "public" | "final")*
*/

package salsa_lite.core.compiler.definitions;

import salsa_lite.core.compiler.SalsaParser;
import salsa_lite.core.compiler.SimpleNode;
import salsa_lite.core.compiler.SymbolTable;

public class BehaviorDeclarationAttributes extends SimpleNode {

	public BehaviorDeclarationAttributes(int id) 					{ super(id); }
	public BehaviorDeclarationAttributes(SalsaParser p, int id)	{ super(p, id); }

	public String getChildCode() {
		if (tokens == null || tokens.length == 0) return "public ";

		String code = "";
		for (int i = 0; i < tokens.length; i++) {
			code += getToken(i).image + " ";
			if (getToken(i).image.equals("abstract")) SymbolTable.isAbstract = true;
		}
		return code;
	}
}
