package salsa_lite.core.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;

import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.Vector;

public class JoinDirectorState extends LiteActorState  {
	public JoinDirectorState(UAN uan) {
		super(uan);
		self = new JoinDirector(getUAN());
	}

	public JoinDirectorState(UAL ual) {
		super(ual);
		self = new JoinDirector(getUAL());
	}

	public JoinDirectorState(String identifier) {
		super(identifier);
		self = new JoinDirector(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 4 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Vector) && (arguments[2] == null || arguments[2] instanceof Vector) && (arguments[3] == null || arguments[3] instanceof Vector)) {
			construct(((Integer)arguments[0]).intValue(), (Vector)arguments[1], (Vector)arguments[2], (Vector)arguments[3]);
			return null;
		}  else if (methodName.equals("resolveJoinToken") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Object)) {
			resolveJoinToken((Integer)arguments[0], (Object)arguments[1]);
			return null;
		}  else if (methodName.equals("sendAllMessages") && arguments.length == 0) {
			sendAllMessages();
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	private  int requiredTokens;
	private  Object[] values;
	private  Vector targetActors;
	private  Vector targetMessages;
	private  Vector targetPositions;
	public void construct(int requiredTokens, Vector targetActors, Vector targetMessages, Vector targetPositions){
		this.requiredTokens = requiredTokens;
		this.targetActors = targetActors;
		this.targetMessages = targetMessages;
		this.targetPositions = targetPositions;
		values = new Object[requiredTokens];
		if (this.requiredTokens==0) 		{
			// sendAllMessages()
			{
				Message __message = new Message( self, self, "sendAllMessages", new Object[]{  }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void resolveJoinToken(Integer tokenPosition, Object value) {
		values[tokenPosition.intValue()] = value;
		requiredTokens--;
		if (requiredTokens==0) 		{
			// sendAllMessages()
			{
				Message __message = new Message( self, self, "sendAllMessages", new Object[]{  }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void sendAllMessages() {
		for (int i = 0; i<targetActors.size(); i++){
			ActorReference target = (ActorReference)targetActors.get(i);
			String messageId = (String)targetMessages.get(i);
			Integer position = (Integer)targetPositions.get(i);
			Object[] arguments = new Object[3];
			arguments[0] = messageId;
			arguments[1] = position;
			if (position.intValue()==-3) arguments[2] = null;
			else arguments[2] = values;
			__messages.add(new Message(self, target, "resolveToken", arguments, null, null));
		}
		{
			// destroy()
			{
				Message __message = new Message( self, self, "destroy", new Object[]{  }, null, null);
				__messages.add( __message );
			}
		}
	}
}