package salsa_lite.core.language.exceptions;

public class MessageHandlerNotFoundException extends SalsaException {

	String[] argTypes;
	String[] argValues;
	String messageName;

	public MessageHandlerNotFoundException(String messageName, Object[] arguments) {
		this.messageName = messageName;
		argTypes = new String[arguments.length];
		argValues = new String[arguments.length];
		for (int i = 0; i < argTypes.length; i++) {
			argTypes[i] = arguments[i].getClass().getName();
			argValues[i] = arguments[i].toString();
		}
	}

	public String toString() {
		String description = "MessageHandlerNotFoundException: could not find message: " + messageName + "\n";
		description += "\targument types: ";
		for (int i = 0; i < argTypes.length; i++) description += argTypes[i] + " ";
		description += "\n\targument values: ";
		for (int i = 0; i < argValues.length; i++) description += argValues[i] + " ";
		return description;
	}
}
