package examples.addressbook;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;

import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.Hashtable;
import java.util.Enumeration;

public class AddressBookState extends LiteActorState  {
	public AddressBookState(UAN uan) {
		super(uan);
		self = new AddressBook(getUAN());
	}

	public AddressBookState(UAL ual) {
		super(ual);
		self = new AddressBook(getUAL());
	}

	public AddressBookState(String identifier) {
		super(identifier);
		self = new AddressBook(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		}  else if (methodName.equals("getName") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			return getName((String)arguments[0]);
		}  else if (methodName.equals("getEmail") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			return getEmail((String)arguments[0]);
		}  else if (methodName.equals("addUser") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String)) {
			return new Boolean(addUser((String)arguments[0], (String)arguments[1]));
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	private  Hashtable name2email;
	void construct(){
		System.err.println("constructing\n");
		name2email = new Hashtable();
	}
	public String getName(String email) {
		System.err.println("getting name by email: "+email);
		if (name2email.contains(email)) {
			Enumeration e = name2email.keys();
			while (e.hasMoreElements()) {
				String name = (String)e.nextElement();
				String e_mail = (String)name2email.get(name);
				if (email.compareTo(e_mail)==0) {
					System.err.println("success.\n");
					return name;
				}
			}
		}
		System.err.println("failure.\n");
		return new String("Unknown user");
	}
	public String getEmail(String name) {
		System.err.println("Getting email by name: "+name);
		String email = (String)name2email.get(name);
		Enumeration e = name2email.keys();
		System.err.println("keys:");
		while (e.hasMoreElements()) {
			System.err.println("\t"+e.nextElement());
		}
		if (email!=null) {
			System.err.println("success.\n");
			return email;
		}
		System.err.println("failure.\n");
		return new String("Unknown user");
	}
	public boolean addUser(String name, String email) {
		System.err.println("added user:\n\tname: "+name+"\n\temail: "+email);
		if (name2email.containsKey(name)||name2email.contains(email)) {
			return false;
		}
		name2email.put(name, email);
		System.err.println("success.");
		return true;
	}
	public void act(String args[]) {
		this.construct();

		if (args.length!=0) {
			{
				// standardOutput<-println("Usage: java -Dactor_uan=<UAN> -Dactor_host=<host> -Dactor_port=<port> examples.addressbook.AddressBook")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java -Dactor_uan=<UAN> -Dactor_host=<host> -Dactor_port=<port> examples.addressbook.AddressBook" }, null, null);
					__messages.add( __message );
				}
			}
			return;
		}
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			// standardOutput<-println("AddressBook at: ")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "AddressBook at: " }, null, token_2_0);
				__messages.add( __message );
			}
			// standardOutput<-println("\tuan: "+getUAN())
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "\tuan: "+getUAN() }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// standardOutput<-println("\thost: "+ServiceFactory.getReception().getLocalHost()+", port: "+ServiceFactory.getReception().getLocalPort())
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "\thost: "+ServiceFactory.getReception().getLocalHost()+", port: "+ServiceFactory.getReception().getLocalPort() }, token_2_1, null);
				__messages.add( __message );
			}
		}
	}
}