package examples.addressbook;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;

import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class GetNameState extends LiteActorState  {
	public GetNameState(UAN uan) {
		super(uan);
		self = new GetName(getUAN());
	}

	public GetNameState(UAL ual) {
		super(ual);
		self = new GetName(getUAL());
	}

	public GetNameState(String identifier) {
		super(identifier);
		self = new GetName(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("getName") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String)) {
			getName((String)arguments[0], (String)arguments[1]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public void act(String args[]) {
		this.construct();

		if (args.length!=2) {
			{
				// standardOutput<-println("Usage: java examples.addressbook.GetName <AddressBookUAN> <Email>")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java examples.addressbook.GetName <AddressBookUAN> <Email>" }, null, null);
					__messages.add( __message );
				}
			}
			return;
		}
		{
			// getName(args[0], args[1])
			{
				Message __message = new Message( self, self, "getName", new Object[]{ args[0], args[1] }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void getName(String uan, String email) {
		try {
			AddressBook book = new AddressBook(new UAN(uan));
			{
				Token token_3_0 = new Token();
				Token token_3_1 = new Token();
				// standardOutput<-print(email+" is: ")
				{
					Message __message = new Message( self, standardOutput, "print", new Object[]{ email+" is: " }, null, token_3_0);
					__messages.add( __message );
				}
				// book<-getName(email)
				{
					Message __message = new Message( self, book, "getName", new Object[]{ email }, token_3_0, token_3_1);
					__messages.add( __message );
				}
				// standardOutput<-println(token)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ token_3_1 }, token_3_1, null);
					__messages.add( __message );
				}
			}
		}
		catch (MalformedUANException e) {
			{
				// standardError<-println("bad addressbook UAN")
				{
					Message __message = new Message( self, standardError, "println", new Object[]{ "bad addressbook UAN" }, null, null);
					__messages.add( __message );
				}
			}
			return;
		}

	}
}