package examples.addressbook;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;

import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class MigrateBookState extends LiteActorState  {
	public MigrateBookState(UAN uan) {
		super(uan);
		self = new MigrateBook(getUAN());
	}

	public MigrateBookState(UAL ual) {
		super(ual);
		self = new MigrateBook(getUAL());
	}

	public MigrateBookState(String identifier) {
		super(identifier);
		self = new MigrateBook(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public void act(String args[]) {
		this.construct();

		if (args.length!=2) {
			{
				// standardOutput<-println("Usage: java examples.addressbook.MigrateBook <AddressBookUAN> <NewUAL>")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java examples.addressbook.MigrateBook <AddressBookUAN> <NewUAL>" }, null, null);
					__messages.add( __message );
				}
			}
			return;
		}
		try {
			AddressBook book = new AddressBook(new UAN(args[0]));
			{
				// book<-migrate(args[1])
				{
					Message __message = new Message( self, book, "migrate", new Object[]{ args[1] }, null, null);
					__messages.add( __message );
				}
			}
		}
		catch (Exception e) {
			System.err.println("Error getting reference to addressbook: "+args[0]);
			System.err.println("\texception: "+e);
			e.printStackTrace();
			System.exit(0);
		}

	}
}