package salsa_lite.examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.Vector;

public class AgentState extends CollectibleActorState  {
	public AgentState(UAN uan) {
		super(uan);
		self = new Agent(getUAN());
	}

	public AgentState(UAL ual) {
		super(ual);
		self = new Agent(getUAL());
	}

	public AgentState(String identifier) {
		super(identifier);
		self = new Agent(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		}  else if (methodName.equals("addLocation") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			addLocation((String)arguments[0]);
			return null;
		}  else if (methodName.equals("printItinerary") && arguments.length == 0) {
			printItinerary();
			return null;
		}  else if (methodName.equals("printTime") && arguments.length == 0) {
			printTime();
			return null;
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	Vector itinerary = new Vector();
	UAL initialLocation;
	long initialTime;
	int hops;
	void construct(){
		initialLocation = this.getUAL();
		initialTime = System.currentTimeMillis();
		hops = 0;
				{
			// standardOutput<-println("Initial Location: "+this.getUAL())
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "Initial Location: "+this.getUAL() }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void addLocation(String ual) {
		hops++;
		try {
			itinerary.add(new UAL(ual));
		}
		catch (Exception e) {
			System.err.println("Error generating ual: "+ual);
			System.err.println("\texception: "+e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	public void printItinerary() {
		System.err.println("Current Time: "+System.currentTimeMillis());
		Token x = new Token("x");
		{
			// token x = standardOutput<-println("Itinerary: ")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "Itinerary: " }, null, x);
				__messages.add( __message );
			}
		}
		for (int i = 0; i<itinerary.size(); i++){
			{
				Token token_3_0 = new Token();
				// standardOutput<-print("\t"+(UAL)itinerary.get(i))
				{
					Message __message = new Message( self, standardOutput, "print", new Object[]{ "\t"+(UAL)itinerary.get(i) }, null, token_3_0);
					Object[] _propertyInfo = { x };
					__message.setProperty( "waitfor", _propertyInfo );
					__messages.add( __message );
				}
				// x = standardOutput<-println()
				Token x_next = new Token("<-_next");
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{  }, token_3_0, x_next);
					__messages.add( __message );
				}
				x = x_next;
			}
		}
		{
			// standardOutput<-println()
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{  }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				Object[] _propertyInfo = { x };
				__message.setProperty( "waitfor", _propertyInfo );
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void printTime() {
		Token x = new Token("x");
		{
			Token token_2_0 = new Token();
			// standardOutput<-println("Migrated "+hops+" times.")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "Migrated "+hops+" times." }, null, token_2_0);
				__messages.add( __message );
			}
			// token x = standardOutput<-println("\tUAL: "+getUAL())
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "\tUAL: "+getUAL() }, token_2_0, x);
				__messages.add( __message );
			}
		}
		if (getUAL().equals(initialLocation)) {
			{
				// x = standardOutput<-println("Time ellapsed: "+new Long(System.currentTimeMillis()-initialTime))
				Token x_next = new Token("<-_next");
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Time ellapsed: "+new Long(System.currentTimeMillis()-initialTime) }, null, x_next);
					Object[] _propertyInfo = { x };
					__message.setProperty( "waitfor", _propertyInfo );
					__messages.add( __message );
				}
				x = x_next;
				// standardOutput<-println("Migration avg time: "+new Long((System.currentTimeMillis()-initialTime)/hops))
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Migration avg time: "+new Long((System.currentTimeMillis()-initialTime)/hops) }, x_next, null);
					__messages.add( __message );
				}
			}
		}
		{
			// standardOutput<-println()
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{  }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				Object[] _propertyInfo = { x };
				__message.setProperty( "waitfor", _propertyInfo );
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void act(String[] args) {
		try {
			Agent agent = Agent.construct(self, new UAN(args[0]), null, -1, new Object[]{}).copy();
			Token synchToken = new Token("synchToken");
			{
				// token synchToken = agent<-printItinerary()
				{
					Message __message = new Message( self, agent, "printItinerary", new Object[]{  }, null, synchToken);
					__messages.add( __message );
				}
			}
			for (int i = 1; i<args.length; i++){
				{
					Token token_4_0 = new Token();
					Token token_4_1 = new Token();
					Token token_4_2 = new Token();
					// agent<-migrate(args[i])
					{
						Message __message = new Message( self, agent, "migrate", new Object[]{ args[i] }, null, token_4_0);
						Object[] _propertyInfo = { synchToken };
						__message.setProperty( "waitfor", _propertyInfo );
						__messages.add( __message );
					}
					// agent<-addLocation(args[i])
					{
						Message __message = new Message( self, agent, "addLocation", new Object[]{ args[i] }, token_4_0, token_4_1);
						__messages.add( __message );
					}
					// agent<-printItinerary()
					{
						Message __message = new Message( self, agent, "printItinerary", new Object[]{  }, token_4_1, token_4_2);
						__messages.add( __message );
					}
					// synchToken = agent<-printTime()
					Token synchToken_next = new Token("<-_next");
					{
						Message __message = new Message( self, agent, "printTime", new Object[]{  }, token_4_2, synchToken_next);
						__messages.add( __message );
					}
					synchToken = synchToken_next;
				}
			}
		}
		catch (Exception e) {
			{
				// standardOutput<-println(e)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ e }, null, null);
					__messages.add( __message );
				}
			}
			{
				// standardOutput<-println("Usage: java migration.Agent <UAN> (<UAL>)*")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java migration.Agent <UAN> (<UAL>)*" }, null, null);
					__messages.add( __message );
				}
			}
		}

	}
}