package salsa_lite.examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class LargeAgentState extends AgentState {
	public LargeAgentState(UAN uan) {
		super(uan);
		self = new LargeAgent(getUAN());
	}

	public LargeAgentState(UAL ual) {
		super(ual);
		self = new LargeAgent(getUAL());
	}

	public LargeAgentState(String identifier) {
		super(identifier);
		self = new LargeAgent(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("setSize") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			setSize(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	byte[] largeData;
	public void setSize(int size) {
		largeData = new byte[size];
	}
	public void act(String[] args) {
		try {
			{
				Token token_3_0 = new Token();
				Token token_3_1 = new Token();
				Token token_3_2 = new Token();
				Token token_3_3 = new Token();
				// setSize(new Integer(args[0]))
				{
					Message __message = new Message( self, self.copy(), "setSize", new Object[]{ new Integer(args[0]) }, null, token_3_0);
					__messages.add( __message );
				}
				// addLocation(args[2])
				{
					Message __message = new Message( self, self.copy(), "addLocation", new Object[]{ args[2] }, token_3_0, token_3_1);
					__messages.add( __message );
				}
				// bind(args[1], args[2])
				{
					Message __message = new Message( self, self.copy(), "bind", new Object[]{ args[1], args[2] }, token_3_1, token_3_2);
					__messages.add( __message );
				}
				// startTime()
				{
					Message __message = new Message( self, self.copy(), "startTime", new Object[]{  }, token_3_2, token_3_3);
					__messages.add( __message );
				}
				// go(args, "3")
				{
					Message __message = new Message( self, self.copy(), "go", new Object[]{ args, "3" }, token_3_3, null);
					__messages.add( __message );
				}
			}
		}
		catch (Exception e) {
			{
				// standardOutput<-println(e)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ e }, null, null);
					__messages.add( __message );
				}
			}
			{
				// standardOutput<-println("Usage: java migration.LargeAgent size UAN UAL (<UAL>)*")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java migration.LargeAgent size UAN UAL (<UAL>)*" }, null, null);
					__messages.add( __message );
				}
			}
		}

	}
}