package salsa_lite.examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import salsa_lite.core.language.LiteActor;

public class RemoteSendState extends CollectibleActorState  {
	public RemoteSendState(UAN uan) {
		super(uan);
		self = new RemoteSend(getUAN());
	}

	public RemoteSendState(UAL ual) {
		super(ual);
		self = new RemoteSend(getUAL());
	}

	public RemoteSendState(String identifier) {
		super(identifier);
		self = new RemoteSend(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public void act(String[] args) {
		try {
			LiteActor a = new LiteActor(new UAL(args[0]));
			{
				// a<-printItinerary()
				{
					Message __message = new Message( self, a, "printItinerary", new Object[]{  }, null, null);
					__messages.add( __message );
				}
			}
		}
		catch (ArrayIndexOutOfBoundsException e) {
			{
				// standardOutput<-println("Usage: java migration.RemoteSend <UAL>")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java migration.RemoteSend <UAL>" }, null, null);
					__messages.add( __message );
				}
			}
		}
		catch (MalformedUALException e) {
			{
				// standardError<-println("Error creating UAL: "+e)
				{
					Message __message = new Message( self, standardError, "println", new Object[]{ "Error creating UAL: "+e }, null, null);
					__messages.add( __message );
				}
			}
		}

	}
}