package examples.trap;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.*;
import java.util.*;

public class TrapState extends CollectibleActorState  {
	public TrapState(UAN uan) {
		super(uan);
		self = new Trap(getUAN());
	}

	public TrapState(UAL ual) {
		super(ual);
		self = new Trap(getUAL());
	}

	public TrapState(String identifier) {
		super(identifier);
		self = new Trap(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("DistributeWork") && arguments.length == 0) {
			return DistributeWork();
		}  else if (methodName.equals("endTimer") && arguments.length == 0) {
			endTimer();
			return null;
		}  else if (methodName.equals("addUpIntegrals") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object[])) {
			return addUpIntegrals((Object[])arguments[0]);
		}  else if (methodName.equals("displayResults") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			displayResults((Double)arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	int noActors = 2;
	double a = 0.0;
	double b = 1.0;
	int n = 1024;
	long initialTime;
	String nameServer = "jupiter.wcl.cs.rpi.edu";
	String theatersFile = "theaters.txt";
	public void act(String args[]) {
		int argc = args.length;
		if (argc>=1) a = Double.valueOf(args[0]).doubleValue();
		if (argc>=2) b = Double.valueOf(args[1]).doubleValue();
		if (argc>=3) n = Integer.parseInt(args[2]);
		if (argc>=4) noActors = Integer.parseInt(args[3]);
		if (argc>=5) nameServer = args[4];
		if (argc>=6) theatersFile = args[5];
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			// DistributeWork()
			{
				Message __message = new Message( self, self.copy(), "DistributeWork", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// displayResults(token)
			{
				Message __message = new Message( self, self.copy(), "displayResults", new Object[]{ token_2_0 }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// endTimer()
			{
				Message __message = new Message( self, self.copy(), "endTimer", new Object[]{  }, token_2_1, null);
				__messages.add( __message );
			}
		}
	}
	public double[][] DistributeWork() {
		Double h = new Double((b-a)/n);
		Integer local_n = new Integer((int)(n/noActors));
		Double local_a;
		Double local_b;
		TrapWorker[] workers = new TrapWorker[noActors];
		for (int i = 0; i<noActors; i++){
			workers[i] = TrapWorker.construct(self, null, null, -1, new Object[]{}).copy();
		}
		Vector theaters = new Vector();
		String theater;
		try {
			BufferedReader in = new BufferedReader(new FileReader(theatersFile));
			while ((theater=in.readLine())!=null) {
				theaters.add(theater);
			}
			in.close();
		}
		catch (IOException ioe) {
			{
				// standardOutput<-println("[error] Can't open the file "+theatersFile+" for reading.")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "[error] Can't open the file "+theatersFile+" for reading." }, null, null);
					__messages.add( __message );
				}
			}
		}

		for (int i = 0; i<noActors; i++){
			{
				// standardOutput<-println("Sending actor "+"uan://"+nameServer+":3030/a"+i+" to "+"rmsp://"+theaters.get(i%theaters.size())+"/a"+i)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Sending actor "+"uan://"+nameServer+":3030/a"+i+" to "+"rmsp://"+theaters.get(i%theaters.size())+"/a"+i }, null, null);
					__messages.add( __message );
				}
			}
			{
				// workers[i]<-bind("uan://"+nameServer+":3030/a"+i, "rmsp://"+theaters.get(i%theaters.size())+"/a"+i)
				{
					Message __message = new Message( self, workers[i], "bind", new Object[]{ "uan://"+nameServer+":3030/a"+i, "rmsp://"+theaters.get(i%theaters.size())+"/a"+i }, null, null);
					__messages.add( __message );
				}
			}
		}
		{
			// standardOutput<-println(">>>>>>Starting the computation")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ ">>>>>>Starting the computation" }, null, null);
				__messages.add( __message );
			}
		}
		initialTime = System.currentTimeMillis();
		{
			Token token_2_0 = new Token();
			// join block
			token_2_0.setJoinDirector();
			for (int i = 0; i<noActors; i++){
				System.out.println("sending work to worker "+i);
				local_a = new Double(a+i*local_n.doubleValue()*h.doubleValue());
				local_b = new Double(local_a.doubleValue()+local_n.doubleValue()*h.doubleValue());
				{
					// workers[i]<-trap(local_a, local_b, local_n, h)
					{
						Message __message = new Message( self, workers[i], "trap", new Object[]{ local_a, local_b, local_n, h }, null, token_2_0);
						__messages.add( __message );
					}
				}
			}
			token_2_0.createJoinDirector();
			// addUpIntegrals(token)
			{
				Message __message = new Message( self, self.copy(), "addUpIntegrals", new Object[]{ token_2_0 }, token_2_0, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void endTimer() {
		long finalTime = System.currentTimeMillis();
		long runningTime = finalTime-initialTime;
		{
			// standardOutput<-println("Running time for Trapezoidal approximation is "+runningTime+" ms.")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "Running time for Trapezoidal approximation is "+runningTime+" ms." }, null, null);
				__messages.add( __message );
			}
		}
	}
	public Double addUpIntegrals(Object[] results) {
		double total = 0.0;
		for (int i = 0; i<results.length; i++){
			total += ((Double)results[i]).doubleValue();
		}
		return new Double(total);
	}
	public void displayResults(Double result) {
		{
			// standardOutput<-println("With n = "+n+" trapezoids, our estimate of the integral on ("+a+","+b+") ="+result.doubleValue()+"with error "+(result.doubleValue()-1.0e0))
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "With n = "+n+" trapezoids, our estimate of the integral on ("+a+","+b+") ="+result.doubleValue()+"with error "+(result.doubleValue()-1.0e0) }, null, null);
				__messages.add( __message );
			}
		}
	}
}