package examples.trap;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.*;

public class TrapWorkerState extends CollectibleActorState  {
	public TrapWorkerState(UAN uan) {
		super(uan);
		self = new TrapWorker(getUAN());
	}

	public TrapWorkerState(UAL ual) {
		super(ual);
		self = new TrapWorker(getUAL());
	}

	public TrapWorkerState(String identifier) {
		super(identifier);
		self = new TrapWorker(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("trap") && arguments.length == 4 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Double) && (arguments[2] == null || arguments[2] instanceof Integer) && (arguments[3] == null || arguments[3] instanceof Double)) {
			return trap((Double)arguments[0], (Double)arguments[1], (Integer)arguments[2], (Double)arguments[3]);
		}  else if (methodName.equals("f") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			return f((Double)arguments[0]);
		}  else if (methodName.equals("add") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Double)) {
			return add((Double)arguments[0], (Double)arguments[1]);
		}  else if (methodName.equals("multiply") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Double)) {
			return multiply((Double)arguments[0], (Double)arguments[1]);
		}  else if (methodName.equals("startIntegral") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Double)) {
			return startIntegral((Double)arguments[0], (Double)arguments[1]);
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public Double trap(Double local_a, Double local_b, Integer local_n, Double h) {
		Token f_local_a = new Token("f_local_a");
		{
			// token f_local_a = f(local_a)
			{
				Message __message = new Message( self, self.copy(), "f", new Object[]{ local_a }, null, f_local_a);
				__messages.add( __message );
			}
		}
		Token f_local_b = new Token("f_local_b");
		{
			// token f_local_b = f(local_b)
			{
				Message __message = new Message( self, self.copy(), "f", new Object[]{ local_b }, null, f_local_b);
				__messages.add( __message );
			}
		}
		Token integral = new Token("integral");
		{
			// token integral = startIntegral(f_local_a, f_local_b)
			{
				Message __message = new Message( self, self.copy(), "startIntegral", new Object[]{ f_local_a, f_local_b }, null, integral);
				__messages.add( __message );
			}
		}
		double x = local_a.doubleValue();
		for (int i = 1; i<=local_n.intValue()-1; i++, x += h.doubleValue()){
			Token f_x = new Token("f_x");
			{
				// token f_x = f(new Double(x))
				{
					Message __message = new Message( self, self.copy(), "f", new Object[]{ new Double(x) }, null, f_x);
					__messages.add( __message );
				}
			}
			{
				// integral = add(integral, f_x)
				Token integral_next = new Token("add_next");
				{
					Message __message = new Message( self, self.copy(), "add", new Object[]{ integral, f_x }, null, integral_next);
					__messages.add( __message );
				}
				integral = integral_next;
			}
		}
		{
			// multiply(integral, h)
			{
				Message __message = new Message( self, self.copy(), "multiply", new Object[]{ integral, h }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public Double f(Double d) {
		double dv = d.doubleValue();
		return new Double(5*dv*dv*dv*dv);
	}
	public Double add(Double d, Double f) {
		double dv = d.doubleValue();
		double fv = f.doubleValue();
		return new Double(dv+fv);
	}
	public Double multiply(Double d, Double f) {
		double dv = d.doubleValue();
		double fv = f.doubleValue();
		return new Double(dv*fv);
	}
	public Double startIntegral(Double d, Double f) {
		return new Double((d.doubleValue()+f.doubleValue())/2.0);
	}
}