package salsa_lite.local;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;

import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import salsa_lite.core.services.ErrorService;
import salsa_lite.core.services.ErrorServiceState;

public class LocalErrorServiceState extends LiteActorState implements ErrorServiceState {
	public LocalErrorServiceState(UAN uan) {
		super(uan);
		self = new LocalErrorService(getUAN());
	}

	public LocalErrorServiceState(UAL ual) {
		super(ual);
		self = new LocalErrorService(getUAL());
	}

	public LocalErrorServiceState(String identifier) {
		super(identifier);
		self = new LocalErrorService(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object)) {
			print((Object)arguments[0]);
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Boolean)) {
			print(((Boolean)arguments[0]).booleanValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Character)) {
			print(((Character)arguments[0]).charValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Byte)) {
			print(((Byte)arguments[0]).byteValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Short)) {
			print(((Short)arguments[0]).shortValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			print(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Long)) {
			print(((Long)arguments[0]).longValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Float)) {
			print(((Float)arguments[0]).floatValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			print(((Double)arguments[0]).doubleValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			print((String)arguments[0]);
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			println((String)arguments[0]);
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object)) {
			println((Object)arguments[0]);
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Boolean)) {
			println(((Boolean)arguments[0]).booleanValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Character)) {
			println(((Character)arguments[0]).charValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Byte)) {
			println(((Byte)arguments[0]).byteValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Short)) {
			println(((Short)arguments[0]).shortValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			println(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Long)) {
			println(((Long)arguments[0]).longValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Float)) {
			println(((Float)arguments[0]).floatValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			println(((Double)arguments[0]).doubleValue());
			return null;
		}  else if (methodName.equals("println") && arguments.length == 0) {
			println();
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	public void construct(){
	}
	public void print(Object p) {
		System.err.print(p);
	}
	public void print(boolean p) {
		System.err.print(p);
	}
	public void print(char p) {
		System.err.print(p);
	}
	public void print(byte p) {
		System.err.print(p);
	}
	public void print(short p) {
		System.err.print(p);
	}
	public void print(int p) {
		System.err.print(p);
	}
	public void print(long p) {
		System.err.print(p);
	}
	public void print(float p) {
		System.err.print(p);
	}
	public void print(double p) {
		System.err.print(p);
	}
	public void print(String s) {
		System.err.print(s);
	}
	public void println(String s) {
		System.err.println(s);
	}
	public void println(Object p) {
		System.err.println(p);
	}
	public void println(boolean p) {
		System.err.println(p);
	}
	public void println(char p) {
		System.err.println(p);
	}
	public void println(byte p) {
		System.err.println(p);
	}
	public void println(short p) {
		System.err.println(p);
	}
	public void println(int p) {
		System.err.println(p);
	}
	public void println(long p) {
		System.err.println(p);
	}
	public void println(float p) {
		System.err.println(p);
	}
	public void println(double p) {
		System.err.println(p);
	}
	public void println() {
		System.err.println();
	}
}