package salsa_lite.tests.distributed_random_fibonacci;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.StringTokenizer;
import java.util.Vector;

public class DRFibonacciState extends CollectibleActorState  {
	public DRFibonacciState(UAN uan) {
		super(uan);
		self = new DRFibonacci(getUAN());
	}

	public DRFibonacciState(UAL ual) {
		super(ual);
		self = new DRFibonacci(getUAL());
	}

	public DRFibonacciState(String identifier) {
		super(identifier);
		self = new DRFibonacci(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 3) {
			construct((String[])arguments[0], (int[])arguments[1], ((Integer)arguments[2]).intValue());
			return null;
		}  else if (methodName.equals("generateUAN") && arguments.length == 0) {
			return generateUAN();
		}  else if (methodName.equals("add") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			return new Integer(add(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue()));
		}  else if (methodName.equals("compute") && arguments.length == 0) {
			return new Integer(compute());
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("finish") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			finish(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("getTheaters") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			getTheaters((String)arguments[0]);
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	String[] hosts;
	int[] ports;
	String name_server;
	int n;
	long initial_time;
	public void construct(String[] hosts, int[] ports, int n){
		this.hosts = hosts;
		this.ports = ports;
		this.n = n;
	}
	int generated = 0;
	public UAN generateUAN() {
		generated++;
		UAN newUAN = null;
		try {
			newUAN = new UAN(getUAN().toString()+"/"+generated);
		}
		catch (Exception e) {
			System.err.println("Exception generating new UAN: "+e);
		}

		return newUAN;
	}
	public int add(int x, int y) {
		return x+y;
	}
	public int compute() {
		if (n==0) 		return 0;
		else if (n<=2) 		return 1;
		else {
			int random_target = (int)(Math.random()*hosts.length);
			DRFibonacci fib1 = DRFibonacci.construct(self, this.generateUAN(), hosts[random_target], ports[random_target], new Object[]{hosts, ports, new Integer(n-1)}).copy();
			random_target = (int)(Math.random()*hosts.length);
			DRFibonacci fib2 = DRFibonacci.construct(self, this.generateUAN(), hosts[random_target], ports[random_target], new Object[]{hosts, ports, new Integer(n-2)}).copy();
			Token x = new Token("x");
			{
				// token x = fib1<-compute()
				{
					Message __message = new Message( self, fib1, "compute", new Object[]{  }, null, x);
					__messages.add( __message );
				}
			}
			Token y = new Token("y");
			{
				// token y = fib2<-compute()
				{
					Message __message = new Message( self, fib2, "compute", new Object[]{  }, null, y);
					__messages.add( __message );
				}
			}
			{
				// add(x, y)
				{
					Message __message = new Message( self, self.copy(), "add", new Object[]{ x, y }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
	}
	public void act(String args[]) {
		if (args.length!=2) {
			System.err.println("Incorrect arguments.");
			System.err.println("Usage:");
			System.err.println("\tjava salsa_lite.tests.distributed_random_fibonacci.DRFibonacci <theaters & nameserver file> <N>");
			System.exit(0);
		}
		String theaters_file = args[0];
		this.getTheaters(theaters_file);
		System.err.println("Parsed theaters, initializing.");
		int n = Integer.parseInt(args[1]);
		System.err.println("beginning computation at: "+System.currentTimeMillis());
		initial_time = System.currentTimeMillis();
		int random_target = (int)(Math.random()*hosts.length);
		UAN generated_uan = null;
		try {
			generated_uan = new UAN(name_server+"initial");
		}
		catch (Exception e) {
			System.err.println("Exception generating new UAN: "+e);
		}

		DRFibonacci worker = DRFibonacci.construct(self, generated_uan, hosts[random_target], ports[random_target], new Object[]{hosts, ports, n}).copy();
		{
			Token token_2_0 = new Token();
			// worker<-compute()
			{
				Message __message = new Message( self, worker, "compute", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// finish(token)
			{
				Message __message = new Message( self, self.copy(), "finish", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
	}
	public void finish(int result) {
		System.err.println("Distributed Random Fibonacci took: "+(System.currentTimeMillis()-initial_time));
		System.err.println("result: "+result);
	}
	public void getTheaters(String theater_file) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(theater_file));
			String line = in.readLine();
			name_server = "uan://"+line+"/";
			line = in.readLine();
			Vector theaters_vector = new Vector();
			while (line!=null) {
				theaters_vector.add(line);
				line = in.readLine();
			}
			hosts = new String[theaters_vector.size()];
			ports = new int[theaters_vector.size()];
			for (int j = 0; j<theaters_vector.size(); j++){
				StringTokenizer st = new StringTokenizer((String)theaters_vector.get(j), ":");
				hosts[j] = st.nextToken();
				ports[j] = Integer.parseInt(st.nextToken());
			}
		}
		catch (Exception e) {
			System.err.println("Error reading theaters file: "+e);
			e.printStackTrace();
		}

	}
}