package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class ContinuationState extends CollectibleActorState  {
	public ContinuationState(UAN uan) {
		super(uan);
		self = new Continuation(getUAN());
	}

	public ContinuationState(UAL ual) {
		super(ual);
		self = new Continuation(getUAL());
	}

	public ContinuationState(String identifier) {
		super(identifier);
		self = new Continuation(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("i") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			return new Integer(i(((Integer)arguments[0]).intValue()));
		}  else if (methodName.equals("d") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			return new Integer(d(((Integer)arguments[0]).intValue()));
		}  else if (methodName.equals("m") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			return new Integer(m(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue()));
		}  else if (methodName.equals("a") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			return new Integer(a(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue()));
		}  else if (methodName.equals("s") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			return new Integer(s(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue()));
		}  else if (methodName.equals("p") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			return new Integer(p(((Integer)arguments[0]).intValue()));
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public int i(int n) {
		return ++n;
	}
	public int d(int n) {
		return n*2;
	}
	public int m(int n1, int n2) {
		return n1*n2;
	}
	public int a(int n1, int n2) {
		return n1+n2;
	}
	public int s(int n1, int n2) {
		return n1-n2;
	}
	public int p(int n) {
		{
			// standardOutput<-print(n+" ")
			{
				Message __message = new Message( self, standardOutput, "print", new Object[]{ n+" " }, null, null);
				__messages.add( __message );
			}
		}
		return n;
	}
	public void act(String[] args) {
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			Token token_2_2 = new Token();
			Token token_2_3 = new Token();
			Token token_2_4 = new Token();
			Token token_2_5 = new Token();
			Token token_2_6 = new Token();
			Token token_2_7 = new Token();
			Token token_2_8 = new Token();
			Token token_2_9 = new Token();
			Token token_2_10 = new Token();
			Token token_2_11 = new Token();
			Token token_2_12 = new Token();
			Token token_2_13 = new Token();
			Token token_2_14 = new Token();
			Token token_2_15 = new Token();
			// i(0)
			{
				Message __message = new Message( self, self.copy(), "i", new Object[]{ new Integer(0) }, null, token_2_0);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_0 }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// d(token)
			{
				Message __message = new Message( self, self.copy(), "d", new Object[]{ token_2_1 }, token_2_1, token_2_2);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_2 }, token_2_2, token_2_3);
				__messages.add( __message );
			}
			// i(token)
			{
				Message __message = new Message( self, self.copy(), "i", new Object[]{ token_2_3 }, token_2_3, token_2_4);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_4 }, token_2_4, token_2_5);
				__messages.add( __message );
			}
			// d(token)
			{
				Message __message = new Message( self, self.copy(), "d", new Object[]{ token_2_5 }, token_2_5, token_2_6);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_6 }, token_2_6, token_2_7);
				__messages.add( __message );
			}
			// i(token)
			{
				Message __message = new Message( self, self.copy(), "i", new Object[]{ token_2_7 }, token_2_7, token_2_8);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_8 }, token_2_8, token_2_9);
				__messages.add( __message );
			}
			// m(token, 10)
			{
				Message __message = new Message( self, self.copy(), "m", new Object[]{ token_2_9, new Integer(10) }, token_2_9, token_2_10);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_10 }, token_2_10, token_2_11);
				__messages.add( __message );
			}
			// a(3, token)
			{
				Message __message = new Message( self, self.copy(), "a", new Object[]{ new Integer(3), token_2_11 }, token_2_11, token_2_12);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_12 }, token_2_12, token_2_13);
				__messages.add( __message );
			}
			// s(token, 1)
			{
				Message __message = new Message( self, self.copy(), "s", new Object[]{ token_2_13, new Integer(1) }, token_2_13, token_2_14);
				__messages.add( __message );
			}
			// p(token)
			{
				Message __message = new Message( self, self.copy(), "p", new Object[]{ token_2_14 }, token_2_14, token_2_15);
				__messages.add( __message );
			}
			// standardOutput<-print("hi")
			{
				Message __message = new Message( self, standardOutput, "print", new Object[]{ "hi" }, token_2_15, null);
				__messages.add( __message );
			}
		}
	}
}