package examples.language.babyfood;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class BabyState extends ManState {
	public BabyState(UAN uan) {
		super(uan);
		self = new Baby(getUAN());
	}

	public BabyState(UAL ual) {
		super(ual);
		self = new Baby(getUAL());
	}

	public BabyState(String identifier) {
		super(identifier);
		self = new Baby(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("eat") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Food)) {
			eat((Food)arguments[0]);
			return null;
		}  else if (methodName.equals("eat") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof BabyFood)) {
			eat((BabyFood)arguments[0]);
			return null;
		}  else if (methodName.equals("toString") && arguments.length == 0) {
			return toString();
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public void eat(Food f) {
		{
			// standardOutput<-println("Sorry, Baby can't eat Food!")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "Sorry, Baby can't eat Food!" }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void eat(BabyFood bf) {
		{
			// bf<-mash()
			{
				Message __message = new Message( self, bf, "mash", new Object[]{  }, null, null);
				__messages.add( __message );
			}
		}
		super.eat(bf);
	}
	public String toString() {
		return "Baby";
	}
	public void act(String[] args) {
		Man m = Man.construct(self, null, null, -1, new Object[]{}).copy();
		Baby b = Baby.construct(self, null, null, -1, new Object[]{}).copy();
		Food f = Food.construct(self, null, null, -1, new Object[]{}).copy();
		BabyFood bf = BabyFood.construct(self, null, null, -1, new Object[]{}).copy();
		{
			// m<-eat(f)
			{
				Message __message = new Message( self, m, "eat", new Object[]{ f }, null, null);
				__messages.add( __message );
			}
		}
		m = b;
		{
			// m<-eat(f)
			{
				Message __message = new Message( self, m, "eat", new Object[]{ f }, null, null);
				__messages.add( __message );
			}
		}
		f = bf;
		{
			// m<-eat(f)
			{
				Message __message = new Message( self, m, "eat", new Object[]{ f }, null, null);
				__messages.add( __message );
			}
		}
		{
			// b<-eat(f)
			{
				Message __message = new Message( self, b, "eat", new Object[]{ f }, null, null);
				__messages.add( __message );
			}
		}
		{
			// b<-eat(bf)
			{
				Message __message = new Message( self, b, "eat", new Object[]{ bf }, null, null);
				__messages.add( __message );
			}
		}
	}
}