package salsa_lite.tests.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.StringTokenizer;
import java.util.Vector;

public class MigrationTesterState extends CollectibleActorState  {
	public MigrationTesterState(UAN uan) {
		super(uan);
		self = new MigrationTester(getUAN());
	}

	public MigrationTesterState(UAL ual) {
		super(ual);
		self = new MigrationTester(getUAL());
	}

	public MigrationTesterState(String identifier) {
		super(identifier);
		self = new MigrationTester(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("create_actors") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			return create_actors(((Integer)arguments[0]).intValue());
		}  else if (methodName.equals("migrate_actors") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof MigrationWorker[]) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			migrate_actors((MigrationWorker[])arguments[0], ((Integer)arguments[1]).intValue());
			return null;
		}  else if (methodName.equals("finish") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			finish(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue());
			return null;
		}  else if (methodName.equals("dummy") && arguments.length == 0) {
			dummy();
			return null;
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("getTheaters") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			getTheaters((String)arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	String[] hosts;
	int[] ports;
	String name_server;
	long initial_time;
	public MigrationWorker[] create_actors(int number_actors) {
		MigrationWorker[] workers = new MigrationWorker[number_actors];
		for (int i = 0; i<number_actors; i++){
			UAN generatedUAN = null;
			try {
				generatedUAN = new UAN(name_server+"worker_"+i);
			}
			catch (Exception e) {
				System.err.println("Exception while generating UAN: "+e);
				e.printStackTrace();
				System.exit(0);
			}

			int target = (int)(hosts.length*Math.random());
			workers[i] = MigrationWorker.construct(self, generatedUAN, hosts[target], ports[target], new Object[]{}).copy();
		}
		return workers;
	}
	public void migrate_actors(MigrationWorker[] workers, int number_migrations) {
		{
			Token token_2_0 = new Token();
			// join block
			token_2_0.setJoinDirector();
			for (int i = 0; i<number_migrations; i++){
				int target = (int)(hosts.length*Math.random());
				{
					// workers[(int)(Math.random()*workers.length)]<-migrate(hosts[target], ports[target])
					{
						Message __message = new Message( self, workers[(int)(Math.random()*workers.length)], "migrate", new Object[]{ hosts[target], ports[target] }, null, token_2_0);
						__messages.add( __message );
					}
				}
			}
			token_2_0.createJoinDirector();
			// dummy()
			{
				Message __message = new Message( self, self.copy(), "dummy", new Object[]{  }, token_2_0, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void finish(int number_actors, int number_migrations) {
		System.err.println("Migration test with "+number_actors+" actors and "+number_migrations+" migrations took: "+(System.currentTimeMillis()-initial_time));
	}
	public void dummy() {
		System.err.println("DUMMY!");
	}
	public void act(String args[]) {
		if (args.length!=3) {
			System.err.println("Incorrect arguments.");
			System.err.println("Usage:");
			System.err.println("\tjava salsa_lite.tests.distributed_random_fibonacci.DRFibonacci <theaters & nameserver file> <number_actors> <number_migrations>");
			System.exit(0);
		}
		String theaters_file = args[0];
		this.getTheaters(theaters_file);
		System.err.println("Parsed theaters, initializing.");
		int number_workers = Integer.parseInt(args[1]);
		int number_migrations = Integer.parseInt(args[2]);
		System.err.println("beginning computation at: "+System.currentTimeMillis());
		initial_time = System.currentTimeMillis();
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			// create_actors(number_workers)
			{
				Message __message = new Message( self, self.copy(), "create_actors", new Object[]{ number_workers }, null, token_2_0);
				__messages.add( __message );
			}
			// migrate_actors(token, number_migrations)
			{
				Message __message = new Message( self, self.copy(), "migrate_actors", new Object[]{ token_2_0, number_migrations }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// finish(number_workers, number_migrations)
			{
				Message __message = new Message( self, self.copy(), "finish", new Object[]{ number_workers, number_migrations }, token_2_1, null);
				__messages.add( __message );
			}
		}
	}
	public void getTheaters(String theater_file) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(theater_file));
			String line = in.readLine();
			name_server = "uan://"+line+"/";
			line = in.readLine();
			Vector theaters_vector = new Vector();
			while (line!=null) {
				theaters_vector.add(line);
				line = in.readLine();
			}
			hosts = new String[theaters_vector.size()];
			ports = new int[theaters_vector.size()];
			for (int j = 0; j<theaters_vector.size(); j++){
				StringTokenizer st = new StringTokenizer((String)theaters_vector.get(j), ":");
				hosts[j] = st.nextToken();
				ports[j] = Integer.parseInt(st.nextToken());
			}
		}
		catch (Exception e) {
			System.err.println("Error reading theaters file: "+e);
			e.printStackTrace();
		}

	}
}