package salsa_lite.tests.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class MigrationWorkerState extends CollectibleActorState  {
	public MigrationWorkerState(UAN uan) {
		super(uan);
		self = new MigrationWorker(getUAN());
	}

	public MigrationWorkerState(UAL ual) {
		super(ual);
		self = new MigrationWorker(getUAL());
	}

	public MigrationWorkerState(String identifier) {
		super(identifier);
		self = new MigrationWorker(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		}  else if (methodName.equals("completedMigration") && arguments.length == 0) {
			completedMigration();
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	public void construct(){
		System.err.println("created migration worker: "+getUAN()+" - "+getUAL());
	}
	public void completedMigration() {
		System.err.println(getUAN()+" completed migration!");
	}
}